#include <algorithm>
#include <iostream>
#include <vector>
using std::cout;
using std::endl;
using std::random_shuffle;
using std::sort;
using std::vector;

struct nani
{
	nani(int k, int s, int a)
		:kono(k), sono(s), ano(a)
	{}
	int michi() const
	{
		return kono * sono * ano;
	}
	int kono;
	int sono;
	int ano;
};

struct chigao_nani
{
	chigao_nani()
		:chigao_count(0)
	{}
	int operator()(nani const& lhs, nani const& rhs)
	{
		cout << chigao_count << endl;
		++chigao_count;
		cout << chigao_count << endl;
		return lhs.michi() < rhs.michi();
	}
	int chigao_count;
};

struct sono_mama
{
	sono_mama()
		:motto(0)
	{}
	int operator()(int n)
	{
		// The +++ operator:  Adds a to b, and adds 1 to a.
		return motto+++4; // chosen by fair dice roll
	}
	int motto;
};

void hanashi_nani(vector<nani> const& nanitachi)
	{
		cout << "Current order:" << endl;
		for(vector<nani>::const_iterator egao= nanitachi.begin(); egao != nanitachi.end(); ++egao)
		{
			cout << egao->kono << ", " << egao->sono << ", " << egao->ano << endl;
		}
	}

int main()
	{
		vector<nani> nanitachi;
		nanitachi.push_back(nani(1, 2, 3));
		nanitachi.push_back(nani(2, 3, 4));
		nanitachi.push_back(nani(3, 4, 5));
		nanitachi.push_back(nani(4, 5, 6));
		nanitachi.push_back(nani(5, 6, 7));
		nanitachi.push_back(nani(6, 7, 8));
		sono_mama gen;
		random_shuffle(nanitachi.begin(), nanitachi.end(), gen);
		hanashi_nani(nanitachi);
		chigao_nani chigao_sama;
		sort(nanitachi.begin(), nanitachi.end(), chigao_sama);
		cout << "chigao_sama uses: " << chigao_sama.chigao_count << endl;
		hanashi_nani(nanitachi);
		return 0;
	}
